#ifndef ETH_FUNCTIONS_H_
#define ETH_FUNCTIONS_H_

#include "uip.h"
#include <stdint.h>

//Flags fr die bestende Ethernetverbindung
extern int eth_flag;
#define	uipflag_connected		0x02
#define	uipflag_send				0x01
#define uipflag_idle				0x00
#define uipflag_stop				0x03

struct eth_msg {
					char*	msg;
					int		characters;
				} message;

//Anfrage Codes von seitens BDE
#define		NOOP									0x01
#define		READ_SVALUE						0x02
#define		WRITE_SVALUE					0x03
#define		WRITE_LIST						0x05
#define		READ_MVALUE						0x06
#define		WRITE_MVALUE					0x07
#define 	READ_STRING						0x08
#define		WRITE_STRING					0x09
#define		READ_CONFIG						0x0A
//Antwort Codes fr BDE
#define		RESULT_NOOP						0xFF		//Antowrt auf NOOP
#define		RESULT_STD						0x00		//fehlerfrei
#define 	ERROR_READ						0xEE		//unplausible Liste
#define		ERROR_READ_M					0xDD		//unplausibles Argument
#define		ERROR_NOSERVEREXE			0xAA		//unbekannter Befehl
#define		ERROR_SERVEROVERLOAD	0xCC		//Serverberlastung
#define		ERROR_NOACCESS				0xBB		//Unerlaubter Zugriff
#define		ERROR_CANOPEN					0x99		//Fehler auf CAN Seite
//FLAGS
#define 	FLAG_FILLUP						1


/*grundlegende Funktionen fr die NEtzwerkschnittstelle
	Returncodes:		0=EXIT_SUCCESS
									1=Verbindung fehlgeschalgen
									2=Kein ACK; Sendevorgang erneut starten
									3=Daten nicht exitent
									4=bertragung abgebrochen
									5=alles gesendet / empfangen
									9=Kein Event gefunde - Progeende
*/
void eth_listen(void);
int eth_send(void);
int eth_receive(void);
void eth_reset(void);
void write_eeprom_ip(uint8_t ip0, uint8_t ip1, uint8_t ip2, uint8_t ip3);
void write_eeprom_hostip(uint8_t ip0, uint8_t ip1, uint8_t ip2, uint8_t ip3);
void write_eeprom_netmask(uint8_t mask0, uint8_t mask1, uint8_t mask2, uint8_t mask3);
void read_eeprom_eth_options(eth_options_struct *eth_options);

void statemachine(void);


// object attribute
#define CAN_DATA_ATTR_NULL    0x00
#define CAN_DATA_ATTR_RO      0x01
#define CAN_DATA_ATTR_WO      0x02
#define CAN_DATA_ATTR_RW      0x03




#endif